Subject: Re: [PATCH v5 1/4] dt-bindings: media: imx258: add bindings for IMX258 sensor

From: Krzysztof Kozlowski <[email-masked]>
Date: Tue, 20 Oct 2020 14:58:52 +0200

On Tue, Oct 20, 2020 at 03:46:54PM +0300, Sakari Ailus wrote:
> On Tue, Oct 20, 2020 at 02:26:21PM +0200, Krzysztof Kozlowski wrote:
> > On Tue, Oct 20, 2020 at 03:00:58PM +0300, Sakari Ailus wrote:
> > > Hi Krzysztof,
> > > 
> > > On Tue, Oct 20, 2020 at 12:54:09PM +0200, Krzysztof Kozlowski wrote:
> > > > On Tue, 20 Oct 2020 at 12:38, Sakari Ailus <[email-masked]> wrote:
> > > > >
> > > > > Hi Krzysztof,
> > > > >
> > > > > On Mon, Oct 19, 2020 at 07:02:44PM +0200, Krzysztof Kozlowski wrote:
> > > > > > Add bindings for the IMX258 camera sensor.  The bindings, just like the
> > > > > > driver, are quite limited, e.g. do not support regulator supplies.
> > > > > >
> > > > > > Signed-off-by: Krzysztof Kozlowski <[email-masked]>
> > > > > > Reviewed-by: Rob Herring <[email-masked]>
> > > > > >
> > > > > > ---
> > > > > >
> > > > > > Changes since v4:
> > > > > > 1. Add clock-lanes,
> > > > > > 2. Add Rob's review,
> > > > > > 3. Add one more example and extend existing one,
> > > > > > 4. Add common clock properties (assigned-*).
> > > > >
> > > > > Using the assigned-* clock properties may be workable for this driver at
> > > > > the moment. But using these properties does not guarantee the external
> > > > > clock frequency intended to be used on the hardware.
> > > > 
> > > > It guarantees it. The clock frequency will be as expected (except if
> > > > someone misconfigures the DTS).
> > > 
> > > Is that guaranteed?
> > > 
> > > I'm not saying no to the approach, but if we change how camera sensor DT
> > > bindings are defined, I'd prefer an informed decision is made on the
> > > matter.
> > > 
> > > > 
> > > > > Using other
> > > > > frequencies *is not* expected to work. That applies to this driver as well.
> > > > 
> > > > This is the binding which is HW description. According to HW datasheet
> > > > other frequencies from described range are accepted and expected to
> > > > work.
> > > 
> > > As per datasheet, yes, different external clock frequencies can be used.
> > > But the link frequency is still not independent of the external clock
> > > frequency.
> > > 
> > > The properties of the sensor's PLL tree determines what can be achieved
> > > given a certain external clock frequency. So picking a wrong external clock
> > > frequency quite possibly means that none of the designated link frequencies
> > > are available, rendering the sensor inoperable.
> > 
> > The driver then controls the HW and knows exactly what is needed. If
> > link frequency (which has its own DT property) requires some clock
> > frequency, the driver will configure the clock to that value. The same
> 
> Well it doesn't if it doesn't get that information from DT.

It will get it - via clk_get_rate(). You do not need DT for this.

> The frequency is usually a range, and looking at these bindings, it's from
> 6 MHz to 27 MHz. That'd be a lot of frequencies for a driver to try.

It does not have to try all of them. Assuming link frequency is fixed,
just use any matching (or hard-coded) input clock frequency. Since the
input clock frequency most likely will be set with assigned-clock-rates,
there will be no job to do for the driver at all. Unless the driver
wants to do something more, of course.

> 
> > going other direction. Driver has the knowledge about both its input
> > clock and link frequency, therefore it can make the best decision.
> 
> Again you're assuming a particular driver implementation.

Actually not, I am talking about bindings as far away from the driver
implementation as possible.  This is why some specific frequency *is
not* part of the bindings.

> 
> Typically only a few frequencies are really available on platforms, so a in
> practice a driver would not be able to get any requested frequency. I
> wouldn't start hard-coding every possible frequency to camera sensor
> drivers

If the driver cannot get requested frequency which it apparently
requires, there is nothing more to do. It's broken HW implementation.
The input clock must be matching requirements, regardless of what
property you put in DT.  You can add "clock-frequency" property, you can
even add "really-i-require-clock-frequency" but if the real HW input
clock does not have, it won't work.

IOW, adding "clock-frequency" property does not change the reality - the
board (HW) must provide given frequency so the entire system works.

> 
> > > > > This, instead of the clock-frequency property, effectively removes the
> > > > > ability to set the correct frequency from the driver, at least with current
> > > > > set of the used APIs.
> > > > 
> > > > It seems you confuse DT bindings with some specific driver
> > > > implementation. Bindings do not describe the driver behavior but the
> > > > HW. The ability to set the correct frequency from the driver is not
> > > > removed. It was never part of the bindings and never should. It is
> > > > part of the driver.
> > > > 
> > > > >
> > > > > I suppose you could add a function to set the assigned clock frequency and
> > > > > keep it, just as clk_set_rate_exclusive does?
> > 
> > I did not reply to this comment, so let me know. Of course, one could
> > add such functions. It's not a job for DT bindings, though.
> 
> I'm not suggesting to add it to DT binding patch. What I'm saying that with
> this approach is looks like it may well be needed.

New properties can always be added to DT. However existing properties
cannot be removed. Their meaning or values cannot be changed.

Best regards,
Krzysztof

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel